<?php

require 'db.php';

$postdata = file_get_contents("php://input");
$request = json_decode($postdata);
if(isset($postdata) && !empty($postdata))
{
$mode = mysqli_real_escape_string($con, trim($request->mode));
$catid = mysqli_real_escape_string($con, trim($request->catid));
$catname = mysqli_real_escape_string($con, trim($request->form_value->catname));
$starttime = mysqli_real_escape_string($con, trim($request->form_value->catstarttime));
$stoptime = mysqli_real_escape_string($con, trim($request->form_value->catstoptime));
$cattiming = mysqli_real_escape_string($con, trim($request->form_value->cattiming));
$filesource = mysqli_real_escape_string($con, trim($request->form_value->fileSource));

$type = mysqli_real_escape_string($con, trim($request->type));
$shop_id = mysqli_real_escape_string($con, trim($request->shop_id));
$shop_code = mysqli_real_escape_string($con, trim($request->shop_code));

include 'token_check.php';

if($token_check)
{
    if($mode == "add")
    {
        if($catname == null ||  $catname == "" || $cattiming == null ||  $cattiming == "")
        {
            $rows = array('status'=>false,'message' => 'Fields Missing');
            echo json_encode($rows);
        }
        else
        {
            if($cattiming == 'Default')
            {
                $sel = $con->query("select start_time,end_time from shop_settings where shop_id='$shop_id' and shop_code='$shop_code'");
                if($row = $sel->fetch_assoc())
                {
                    $starttime = $row['start_time'];
                    $stoptime = $row['end_time'];
                }
            }
            
            if($filesource == null || $filesource == "")
            {
                $sql = "INSERT INTO category(shop_id,shop_code,catname,cattime,catstarttime,catstoptime,catstatus) VALUES ('$shop_id','$shop_code','$catname','$cattiming','$starttime','$stoptime','1')";
                $result = mysqli_query($con,$sql);
                if($result)
                {
                    $rows = array('status'=>true,'message' => 'Category Added');
                    echo json_encode($rows);
                }
            }
            else
            {
                $url = $file_upload_url."/".$city_path."/".$cat_path."/".$shop_id;
                $type_path = strtolower($type);
                if (!file_exists($url . $type_path)) {
                    mkdir($url . "/" . $type_path, 0777, true);
                    $upload_url = $url. "/" .$type_path;
                }
                else
                {
                    $upload_url = $url. "/" .$type_path;
                }

                $image_parts = explode(";base64,", $filesource);
                $image_type_aux = explode("image/", $image_parts[0]);
                $image_type = $image_type_aux[1];
                $image_base64 = base64_decode($image_parts[1]);
                
                $image_file_name = uniqid(). '.png';
                $uploadfile = $upload_url  . "/" . $image_file_name;
                
                $accesspath = $file_upload_extension_url. "/" .$city_path. "/" .$cat_path. "/" .$shop_id. "/";
                $savefile = $accesspath . $type_path. "/" . $image_file_name;

                file_put_contents($uploadfile, $image_base64);
                
                $sql = "INSERT INTO category(shop_id,shop_code,catname,cattime,catstarttime,catstoptime,catimg,catstatus) VALUES ('$shop_id','$shop_code','$catname','$cattiming','$starttime','$stoptime','$savefile','1')";
                $result = mysqli_query($con,$sql);
                if($result)
                {
                    $rows = array('status'=>true,'message' => 'Category Added');
                    echo json_encode($rows);
                }
            }
            
        }
    }

    else if($mode == "edit")
    {
        if($catname == "" || $catid == "" || $cattiming == null ||  $cattiming == "")
        {
            $rows = array('status'=>false,'message' => 'Fields Missing');
            echo json_encode($rows);
        }
        else
        {
            if($cattiming == 'Default')
            {
                $sel = $con->query("select start_time,end_time from shop_settings where shop_id='$shop_id' and shop_code='$shop_code'");
                if($row = $sel->fetch_assoc())
                {
                    $starttime = $row['start_time'];
                    $stoptime = $row['end_time'];
                }
            }
            
            if($filesource == "")
            {
                $sql = "UPDATE category set catname = '$catname',cattime = '$cattiming',catstarttime = '$starttime',catstoptime = '$stoptime' where id = '$catid' and shop_id = '$shop_id'";
                $result = mysqli_query($con,$sql);
                if($result)
                {
                    $rows = array('status'=>true,'message' => 'Category Updated');
                    echo json_encode($rows);
                }
            }
            else
            {
                $type_path = strtolower($type);
                $upload_url = $file_upload_url."/".$city_path."/".$cat_path."/".$shop_id. "/" .$type_path;

                $image_parts = explode(";base64,", $filesource);
                $image_type_aux = explode("image/", $image_parts[0]);
                $image_type = $image_type_aux[1];
                $image_base64 = base64_decode($image_parts[1]);
                
                $image_file_name = uniqid(). '.png';
                $uploadfile = $upload_url  . "/" . $image_file_name;
                
                $accesspath = $file_upload_extension_url. "/" .$city_path. "/" .$cat_path. "/" .$shop_id. "/";
                $savefile = $accesspath . $type_path. "/" . $image_file_name;

                file_put_contents($uploadfile, $image_base64);
                
                $sql = "UPDATE category set catname = '$catname',catimg = '$savefile',cattime = '$cattiming',catstarttime = '$starttime',catstoptime = '$stoptime' where id = '$catid' and shop_id = '$shop_id'";
                $result = mysqli_query($con,$sql);
                if($result)
                {
                    $rows = array('status'=>true,'message' => 'Category Updated');
                    echo json_encode($rows);
                }
            }
            
        }
    }
    
    else if($mode == "delete")
    {
        if($catid == "")
        {
            $rows = array('status'=>false,'message' => 'Category Error');
            echo json_encode($rows);
        }
        else
        {
            $sql = "DELETE FROM category where id ='$catid' and shop_id = '$shop_id'";
            $result = mysqli_query($con,$sql);
            if($result)
            {
                $rows = array('status'=>true,'message' => 'Category Deleted');
                echo json_encode($rows);
            }
        }
    }
}
else
{
    $rows = array('status'=>false,'message' => 'Data Error');
    echo json_encode($rows);
}
}
// else
// {
//     header("location: https://iconxtechnologies.in/404");
//     exit();
// }

?>
